;Form Editor
;Written by Thomas A. Stevenson (aka wargamer)
;Blitz Basic 1.50
;www.wargame-programming.com
;3/8/2002
;
;Tips for using
;	start a new form from the File menu
; Add objects from the Add menu
;	Position objects by dragging
;	Fine positioning/sizing can be done from the properties box on right
; Multiple objects can be selected by holding down the shift key
; The first object selected is one the rest aline on when commanded
;	When complete, use Make bb under the File Menu
;	
;Note
;	nFF=Form(xForm,0)
; FF(0)=Form(xForm,1) == master object
; FF(i)=Form(xForm,i+1)

;program control globals
Global DataFile$="formsave"
Global cFF,nFF,cType,xForm,nSelected,MaxFF=100
Const  ALT1=56,ALT2=184,SHIFT1=54,SHIFT2=42,CONTROL1=29,CONTROL2=157
Const  LowB=256*256-1,LongMask=256*256*256*256-1,HighWord=lowB Shl 16
Dim FF(MaxFF),MF(15,11),tt(11),SELECTED(MaxFF),temp(10)

;screen and window globals
Global ScrnW=1024, ScrnH=768
;Global ScrnW=800, ScrnH=600
Global WinX=10,WinY=20
Global winH=scrnH-120, WinW=ScrnW-30-WinX
Global ScreenImage,Hslider,Vslider,HButton,VButton,HSliderSize,VSliderSize
Global SliderWidth=12,Scroll_short=50,Scroll_Long=300, dragdelay=100


Include "Initialize.bb"
Include "Forms.bb"
Include "Menus.bb"

;*************************** Initialize Stuff *********************
Graphics ScrnW, ScrnH
Setup_Graphics()
Setup_Colors()
Setup_Sound()


Setup_Forms()

Restore menudata
Menu_Load()

	xForm=15	;default index for form being created
	FF(0)=obj_assign(xForm,0,200,200,200,250,white,ltgray ,0,2,"","")
	FF(1)=obj_assign(xForm,1,20, 30, 100,20,Black,False ,Fnt0,0,"Text Object","")
	FF(2)=obj_assign(xform,2,20, 60, 100,20,Black,Red ,Fnt0,True,"LABEL","")
	FF(3)=obj_assign(xform,3,20, 90, 100,20,Gray,Black ,Fnt0,0,"BUTTON","")
	FF(4)=obj_assign(xform,4,20,113,  14,14,0,0 ,Fnt0,0,"Checkbox","")
	FF(5)=obj_assign(xform,5,20,132,  16,16,0,Grp,Fnt0,0,"Radio","")
	FF(6)=obj_assign(xform,6,20,150, 100,20,Black,Red ,Fnt0,True,"Edit box","")
	FF(7)=obj_assign(xform,7,20,180, 100,10,1,0 ,100,10,"","")
	FF(8)=obj_assign(xform,8,170,20, 16,100,1,0 ,100,10,"","")
	FF(9)=obj_assign(xform,9,0,0,199,20,0,0,fnt0,True,"Title Bar","")
	cFF=0: nFF=9

	cType=0
	For i=1 To 8
		obj(MF(cType,i),8)=obj(FF(cFF),i)
	Next
	objText$(MF(cType,9))=objText$(FF(cFF))
	objText$(MF(cType,11))=ReturnText$(FF(cFF))
	

;******************  Main ************************************

Repeat

	;update screen
	Screen_Update()   
	Form_Update(cType)
		
	mx=MouseX()
	my=MouseY()
	DrawImage MouseImage,mx,my
	Flip

	;process input
	keyObj=Form_Keys(cType,MF(cType,10),ScreenImage)
	
	If MouseDown(1) Then
		ObjIndex=Form_Event_Check(cType,MF(cType,10),ScreenImage)
	
		If MENU_Activate (mx,my)
			;add xForm to screenimage before passing control to Menu_get()
			SetBuffer ImageBuffer(screenimage)
			Form_Update(cType)
			SetBuffer BackBuffer()
			menupick$=MENU_Get$(mx,ScreenImage)
			If Len(menupick$)>0 Then Process_Menu(menupick$)
		ElseIf Shift_Select(mx,my)
			PlaySound(snd4)
			While MouseDown(1): Wend
		ElseIf Object_Resize(mx,my)
			While MouseDown(1): Wend
		ElseIf Object_Move_Select(mx,my)
		EndIf
		
	EndIf
	
	;check for menu related key press
	menupick$=MENU_Key$()
	If Len(menupick$)>0 Then Process_Menu(menupick$)
	
	Select ReturnText$(ObjIndex)
	Case "CAN"
		Exit
	Case "DONE"
		Exit
	End Select
	
	;update current object properties
	For i=1 To 8
		obj(FF(cFF),i)=obj(MF(cType,i),8)
	Next
	objText$(FF(cFF))=objText$(MF(cType,9))
	ReturnText$(FF(cFF))=objText$(MF(cType,11))

Until KeyDown(1)


While KeyDown(1):Wend
Repeat: Until Not(MouseDown(1))
End


Function Process_Menu(m$)

	Select m$
	Case ""
	Case "SSHOT"
		F$="Form Edit.bmp"
		saveBMP(F$)
		message("Screen Shot saved as "+f$,5000,ScreenImage)
	Case "DEL"
		If cFF=0 Then Return  ;cann't delete master object
		message("Deleting "+cFF,2000,ScreenImage)
		Form_Object_remove(XForm,FF(cFF))
		For n=0 To Form(XForm,0)-1
			FF(n)=Form(Xform,n+1)
		Next		
		cFF=cFF-1
		nFF=Form(XForm,0)
		Object_Activate(cFF)		
	Case "SPH"
		Object_Space("H")
	Case "SPV"
		Object_Space("V")
	Case "DUP"
		nFF=nFF+1
		For i=0 To 8
			TT(i)=obj(FF(cFF),i)
		Next
		tt(1)=tt(1)+20
		tt(2)=tt(2)+20
		FF(nFF)=obj_assign(xform,tt(0),tt(1),tt(2),tt(3),tt(4),tt(5),tt(6),tt(7),tt(8),"Duplicate","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "ALL"
		Object_Aline("Left")
	Case "ALR"
		Object_Aline("Right")
	Case "ALT"
		Object_Aline("Top")
	Case "ALB"
		Object_Aline("Bottom")
	Case "ALC"
		Object_Aline("Vertical")
	Case "ALH"
		Object_Aline("Horizontial")
	Case "TBAR"
		nFF=nFF+1
		FF(nFF)=obj_assign(xform,9,0,0,obj(FF(0),3)-1,20,0,0,fnt0,True,"Title Bar","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "TEXT"
		nFF=nFF+1
		FF(nFF)=obj_assign(xForm,1,20, 30, 100,20,Black,False ,Fnt0,0,"Text Object","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "LAB"
		nFF=nFF+1
		FF(nFF)=obj_assign(xform,2,20, 60, 100,20,Black,Red ,Fnt0,True,"LABEL","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "BUT"
		nFF=nFF+1
		FF(nFF)=obj_assign(xform,3,20, 90, 100,20,Gray,Black ,Fnt0,0,"BUTTON","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "CKBOX"
		nFF=nFF+1
		FF(nFF)=obj_assign(xform,4,20,113,  14,14,0,0 ,Fnt0,0,"Checkbox","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "RAD"
		nFF=nFF+1
		FF(nFF)=obj_assign(xform,5,20,132,  16,16,0,Grp,Fnt0,0,"Radio","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "EDIT"
		nFF=nFF+1
		FF(nFF)=obj_assign(xform,6,20,150, 100,20,Black,Red ,Fnt0,True,"Edit box","")
		cFF=nFF
		Object_Activate(cFF)		
	Case "NEW"
		atext$(1)="Start New Form ?"
		Button$(1)=" NEW "
		Button$(2)="CANCEL"
		If ALERT(2,2,screenimage)=2 Then Return

		tot_obj=FF(0)-1
		Form(xForm,0)=0
		FF(0)=obj_assign(xForm,0,200,200,200,250,white,ltgray ,0,2,"","")
		cFF=0: nFF=0
		
		Object_Activate(cFF)		
	Case "SAVE"
		f=WriteFile(DataFile$+".dat")
		WriteInt f,nFF
		For k=0 To nFF
			For i=0 To 8
				WriteInt f,obj(FF(k),i)
			Next
			WriteString f,objText$(FF(k))			
			WriteString f,ReturnText$(FF(k))			
		Next
		CloseFile(f)
	Case "LOAD"
	  If FileType(DataFile$+".dat")<>1 Then 
			message(DataFile$+".dat  Data file not found",5000,ScreenImage)
			Return
	  EndIf
		Dim temp(8)
		tot_obj=FF(0)-1
		Form(xForm,0)=0
		f=OpenFile(DataFile$+".dat")
		nFF=ReadInt(f)
		Cls
		For k=0 To nFF
			For i=0 To 8
				temp(i)=ReadInt(f)
			Next
			t1$=ReadString(f)
			t2$=ReadString(f)
			FF(i)=obj_assign(xForm,temp(0),temp(1),temp(2),temp(3),temp(4),temp(5),temp(6),temp(7),temp(8),t1$,t2$)		
			Text 20,20*k,t1$+"  "+t2$
		Next
		CloseFile(f)
		Flip
		WaitKey()
		cFF=0	
		Object_Activate(cFF)	
	Case "MAKE"
		f=WriteFile(DataFile$+".bb")
		WriteLine f,"xForm=1"
		For k=0 To nFF
			Object_Write(f,FF(k))
		Next		
		
		WriteLine f,"xHand=Form_Image(xForm)"
		WriteLine f,"Repeat"
		WriteLine f,"	ObjIndex=Form_Control(xForm,xHand,ScreenImage)"
		WriteLine f,"	Select ReturnText$(ObjIndex)"
		WriteLine f,"	Case "+Chr$(34)+Chr$(34)
		For k=0 To nFF
			If Len(ReturnText$(FF(k))) Then
				WriteLine f,"	Case "+Chr$(34)+ReturnText$(FF(k))+Chr$(34)
			EndIf
		Next
		WriteLine f,"	End Select"
		WriteLine f,"Until keydown(1)"
		WriteLine f,"FreeImage xHand"
		WriteLine f,"End"
		
		CloseFile(f)
	Case "QUIT"
		End
	Case "NEXT"
		cFF=cFF+1
		If cFF>nFF Then cFF=0
		cType=obj(FF(cFF),0)
		For i=1 To 8
			obj(MF(cType,i),8)=obj(FF(cFF),i)
		Next
		objText$(MF(cType,9))=objText$(FF(cFF))
		objText$(MF(cType,11))=ReturnText$(FF(cFF))
	End Select

End Function


Function Object_Write(f,ID)

	s$="obj_assign(xForm,"
	For i=0 To 4
		s$=s$+Str$(obj(ID,i))+","
	Next
	
	Select obj(ID,0)
	Case 0,2,3,6,9
		s$=s$+ct$(obj(ID,5))+","+ct$(obj(ID,6))+","
	Case 1,8
		s$=s$+ct$(obj(ID,5))+","+Str$(obj(ID,6))+","
	Case 4,5,7
		s$=s$+Str$(obj(ID,5))+","+Str$(obj(ID,6))+","
	Default
		s$="error obj type "+obj(ID,0)+" "
	End Select
	
	If obj(ID,0)=0 Then
		s$=s$+Str$(obj(ID,7))+","
	ElseIf obj(ID,0)<7 Then
		s$=s$+"FontHand("+Str$(obj(ID,7))+"),"
	Else
		s$=s$+Str$(obj(ID,7))+","
	EndIf
	s$=s$+Str$(obj(ID,8))+","
		
	WriteLine f,s$+Chr$(34)+objText$(ID)+Chr$(34)+","+Chr$(34)+ReturnText$(ID)+Chr$(34)+")"			
	
End Function



Function Object_Activate(c)		
	cType=obj(FF(c),0)
	For i=1 To 8
		obj(MF(cType,i),8)=obj(FF(c),i)
	Next
	objText$(MF(cType,9))=objText$(FF(c))
	objText$(MF(cType,11))=ReturnText$(FF(c))
End Function


Function Shift_Select(mx,my)
	If Not(KeyDown(SHIFT1) Or KeyDown(SHIFT2)) Then Return False

	If Not(RectsOverlap(mx,my,1,1,obj(FF(0),1),obj(FF(0),2),obj(FF(0),3),obj(FF(0),4)))
		Return False
		;not in form area
	EndIf
	
	;subtract master coordinates from mouse coordinates before checking
	mx=mx-obj(FF(0),1)
	my=my-obj(FF(0),2)
	For i=1 To nFF
		If RectsOverlap(mx,my,1,1,obj(FF(i),1),obj(FF(i),2),obj(FF(i),3),obj(FF(i),4))
			Object_list_Update(i)
			Return True
		EndIf
	Next
	
End Function


Function Object_Space(VH$)

	If nSelected<3 Then Return
	Dim temp(nSelected)
	
	Select VH$
	Case "V"
		c1=2: c2=4
	Case "H"
		c1=1: c2=3
	End Select

	;make list 
	For k=1 To MaxFF
		If SELECTED(k)>nSelected Then 
			message("k>nSelected ",5000,screenimage)
			Return
		ElseIf SELECTED(k)>0 Then
			;store object index by selection order 
			temp(SELECTED(k))=FF(k)
		EndIf
	Next
	;check list for proper sequence
	For k=1 To nSelected-1
		If obj(temp(k),c1)>obj(temp(k+1),c1) Then 
			message("Objects not selected in Left/Top |to Right/bottom order ",5000,screenimage)
			Return
		EndIf
	Next
		
	;check for enough space
	For k=1 To nSelected
		required_width = required_width + obj(temp(k),c2)
	Next
	Avail_width = obj(temp(nSelected),c1)+obj(temp(nSelected),c2)-obj(temp(1),c1)
	If required_width > Avail_width
		Stop
		message("Not enough Space "+required_width,5000,screenimage)
		Return
	EndIf
	
	;calculate white space and reposition middle objects
	whitespace = (Avail_width - required_width)/(nSelected-1)
	For k=2 To nSelected-1
		obj(temp(k),c1)=obj(temp(k-1),c1)+obj(temp(k-1),c2)+whitespace
	Next
	
End Function



Function Object_Aline(A$)

	If nSelected<2 Then Return

	Select A$
	Case "Left"
		For k=1 To MaxFF
			If SELECTED(k)>1 Then obj(FF(k),1)=obj(FF(cFF),1) 
		Next
	Case "Right"
		x2=obj(FF(cFF),1)+obj(FF(cFF),3) 
		For k=1 To MaxFF
			If SELECTED(k)>1 Then obj(FF(k),1)=x2-obj(FF(k),3) 
		Next
	Case "Top"
		For k=1 To MaxFF
			If SELECTED(k)>1 Then obj(FF(k),2)=obj(FF(cFF),2) 
		Next
	Case "Bottom"
		y2=obj(FF(cFF),2)+obj(FF(cFF),4) 
		For k=1 To MaxFF
			If SELECTED(k)>1 Then obj(FF(k),2)=y2-obj(FF(k),4) 
		Next
	Case "Vertical"
		cx=obj(FF(cFF),1)+obj(FF(cFF),3) Shr 1 
		For k=1 To MaxFF
			If SELECTED(k)>1 Then obj(FF(k),1)=cx-obj(FF(k),3) Shr 1
		Next
	Case "Horizontial"
		cy=obj(FF(cFF),2)+obj(FF(cFF),4) Shr 1 
		For k=1 To MaxFF
			If SELECTED(k)>1 Then obj(FF(k),2)=cy-obj(FF(k),4) Shr 1
		Next
	End Select

End Function


Function Object_list_Update(i)
	If SELECTED(i) Then 
		For k=0 To MaxFF
			If SELECTED(k)>SELECTED(i) Then SELECTED(k)=SELECTED(k)-1
		Next
		SELECTED(i)=False 
		nSelected=nSelected-1
	Else 
		nSelected=nSelected+1
		SELECTED(i)=nSelected
	EndIf

	;find index of first object in list
	cFF=0
	For k=1 To MaxFF
		If SELECTED(K)=1 Then cFF=k
	Next

	cType=obj(FF(cFF),0)
	For k=1 To 8
		obj(MF(cType,k),8)=obj(FF(cFF),k)
	Next
	objText$(MF(cType,9))=objText$(FF(cFF))
	objText$(MF(cType,11))=ReturnText$(FF(cFF))
End Function


Function Object_select(mx,my)

	If Not(RectsOverlap(mx,my,1,1,obj(FF(0),1),obj(FF(0),2),obj(FF(0),3),obj(FF(0),4)))
		Return False
		;not in form area
	EndIf
	
	;clear shift selected list
	PlaySound(snd4)
	nSelected=0
	For i=0 To MaxFF
		Selected(i)=False
	Next
	
	;subtract master coordinates from mouse coordinates before checking
	mx=mx-obj(FF(0),1)
	my=my-obj(FF(0),2)
	For i=1 To nFF
		If RectsOverlap(mx,my,1,1,obj(FF(i),1),obj(FF(i),2),obj(FF(i),3),obj(FF(i),4))
			cFF=i
			cType=obj(FF(cFF),0)
			For k=1 To 8
				obj(MF(cType,k),8)=obj(FF(cFF),k)
			Next
			objText$(MF(cType,9))=objText$(FF(cFF))
			objText$(MF(cType,11))=ReturnText$(FF(cFF))
			Return True
		EndIf
	Next
	
	If cFF=0 Then Return True
	
	;defult master form
	cFF=0
	cType=obj(FF(cFF),0)
	For k=1 To 8
		obj(MF(cType,k),8)=obj(FF(cFF),k)
	Next
	objText$(MF(cType,9))=objText$(FF(cFF))
	objText$(MF(cType,11))=ReturnText$(FF(cFF))
	Return True

End Function


Function Object_Resize(mx,my)

	mx=mx-obj(FF(0),1)
	my=my-obj(FF(0),2)
	If obj(FF(cFF),0)=0 Then 
		;master object
		If RectsOverlap(mx,my,1,1,obj(FF(cFF),3),(obj(FF(cFF),4) Shr 1) -6,4,12)
			Resize_box(obj(FF(0),1),obj(FF(0),2),obj(FF(cFF),3),obj(FF(cFF),4),1)
			Return True
		ElseIf RectsOverlap(mx,my,1,1,(obj(FF(cFF),3) Shr 1) -6,obj(FF(cFF),4),12,4)
			Resize_box(obj(FF(0),1),obj(FF(0),2),obj(FF(cFF),3),obj(FF(cFF),4),0)
			Return True
		EndIf
	Else
		;daugter object
		hx = obj(FF(cFF),1) + (obj(FF(cFF),3) Shr 1) -6
		hy = obj(FF(cFF),2) + (obj(FF(cFF),4) Shr 1) -6
		x0=obj(FF(0),1)+obj(FF(cff),1)
		y0=obj(FF(0),2)+obj(FF(cff),2)
		If     RectsOverlap(mx,my,1,1,obj(FF(cFF),1)+obj(FF(cFF),3),hy,4,12)
			Resize_box(x0,y0,obj(FF(cFF),3),obj(FF(cFF),4),1)
			Return True
		ElseIf RectsOverlap(mx,my,1,1,hx,obj(FF(cFF),2)+obj(FF(cFF),4),12,4)
			Resize_box(x0,y0,obj(FF(cFF),3),obj(FF(cFF),4),0)
			Return True
		EndIf
	EndIf
	
End Function


Function Resize_Box(x,y,w,h,t)

	Screen_Partial_Draw(1)

	While MouseDown(1)
		;update screen
		DrawBlock ScreenImage,0,0
		Form_Draw(xForm)
		Form_Update(cType)
		
		mx=MouseX()
		my=MouseY()
		;colorset(white)
		If t=1
			;Rect x,y,(mx-x),h,0
			obj(MF(cType,3),8)=mx-x
			obj(FF(cFF),3)=mx-x
		Else
			;Rect x,y,w,(my-y),0
			obj(MF(cType,4),8)=my-y
			obj(FF(cFF),4)=my-y
		EndIf
		DrawImage MouseImage,mx,my
		Flip
	Wend
	
End Function


Function Object_Move_Select(mx,my)

	t0=MilliSecs()
	While MouseDown(1)
		If MilliSecs()-t0>dragdelay Then 
			;drag event
			;recalculate mouse coordinates relative to master object
			rx=mx-obj(FF(0),1)
			ry=my-obj(FF(0),2)
			If obj(FF(cFF),0)=0 Then 
				;master object
				If RectsOverlap(rx,ry,1,1,0,0,obj(FF(cFF),3),obj(FF(cFF),4))
					Move_Box()
					Return True
				EndIf
			ElseIf RectsOverlap(rx,ry,1,1,obj(FF(cFF),1),obj(FF(cFF),2),obj(FF(cFF),3),obj(FF(cFF),4))
				Move_box()
				Return True
			Else
				;daugter object
				For i=1 To nFF
					If selected(i)=0
					ElseIf RectsOverlap(rx,ry,1,1,obj(FF(i),1),obj(FF(i),2),obj(FF(i),3),obj(FF(i),4))
						Move_box()
						Return True
					EndIf
				Next
			EndIf
		EndIf
	Wend
	;else single click event
	Return Object_select(mx,my)

End Function


Function Move_Box()

		;calculate offset from mouse position to upper right corner of object
		;note dx,dy also includes correction for master object x,y
		dx=obj(FF(cFF),1)-MouseX()
		dy=obj(FF(cFF),2)-MouseY()
		Screen_Partial_Draw(1)

		While MouseDown(1)
			mx=MouseX()
			my=MouseY()
			;store position of 1st object before move
			hx=obj(FF(cFF),1)
			hy=obj(FF(cFF),2)
			;move first object
			obj(MF(cType,1),8)=MAX(mx+dx,0) 
			obj(MF(cType,2),8)=MAX(my+dy,0)
			obj(FF(cFF),1)=obj(MF(cType,1),8)
			obj(FF(cFF),2)=obj(MF(cType,2),8)
			
			rx=obj(FF(cFF),1)-hx
			ry=obj(FF(cFF),2)-hy
			For i=0 To nFF
				If i=cFF
				ElseIf SELECTED(i)
					obj(FF(i),1)=obj(FF(i),1)+rx
					obj(FF(i),2)=obj(FF(i),2)+ry
				EndIf
			Next

			DrawBlock ScreenImage,0,0
			Form_Draw(xform)
			Form_Update(cType)
			DrawImage mouseImage,mx,my
			Flip
		Wend
		
End Function


Function Screen_Partial_Draw(n)
	SetBuffer ImageBuffer(screenimage)
	ClsColor 100,100,100
	Cls
	MENU_DRAW()
	DrawBlock MF(cType,10),obj(Form(cType,1),1),obj(Form(cType,1),2)
	If n=1
		;Xform being moved 
	Else
		Form_Draw(xForm)
		colorset(Yellow)
		For i=1 To nFF
			If SELECTED(i) Then Rect obj(FF(0),1)+obj(FF(i),1),obj(FF(0),2)+obj(FF(i),2),obj(FF(i),3),obj(FF(i),4),0
		Next
	EndIf
	If nSelected>0 Then
		colorset(black)
		SetFont fonthand(0)
		Text 10,scrnH-20,"Number of Objects Selected "+nSelected
	EndIf
	SetBuffer BackBuffer()

End Function


Function Screen_Update()

	SetBuffer ImageBuffer(screenimage)
	ClsColor 100,100,100
	Cls
	MENU_DRAW()
	DrawBlock MF(cType,10),obj(Form(cType,1),1),obj(Form(cType,1),2)
	Form_Draw(xForm)
	colorset(Yellow)
	For i=1 To nFF
		If SELECTED(i) Then Rect obj(FF(0),1)+obj(FF(i),1),obj(FF(0),2)+obj(FF(i),2),obj(FF(i),3),obj(FF(i),4),0
	Next
	If nSelected>0 Then
		colorset(black)
		SetFont fonthand(0)
		Text 10,scrnH-20,"Number of Objects Selected "+nSelected
	EndIf
	SetBuffer BackBuffer()
	DrawBlock ScreenImage,0,0
	
End Function